-- CreateEnum
CREATE TYPE "Frequency" AS ENUM ('PUNCTUAL', 'RECURRENT');

-- CreateTable
CREATE TABLE "ad" (
    "uuid" UUID NOT NULL,
    "userUuid" UUID NOT NULL,
    "driver" BOOLEAN NOT NULL,
    "passenger" BOOLEAN NOT NULL,
    "frequency" "Frequency" NOT NULL,
    "fromDate" DATE NOT NULL,
    "toDate" DATE NOT NULL,
    "seatsProposed" SMALLINT NOT NULL,
    "seatsRequested" SMALLINT NOT NULL,
    "strict" BOOLEAN NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,

    CONSTRAINT "ad_pkey" PRIMARY KEY ("uuid")
);

-- CreateTable
CREATE TABLE "schedule_item" (
    "uuid" UUID NOT NULL,
    "adUuid" UUID NOT NULL,
    "day" INTEGER NOT NULL,
    "time" TIME(4) NOT NULL,
    "margin" INTEGER NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,

    CONSTRAINT "schedule_item_pkey" PRIMARY KEY ("uuid")
);

-- CreateTable
CREATE TABLE "waypoint" (
    "uuid" UUID NOT NULL,
    "adUuid" UUID NOT NULL,
    "position" SMALLINT NOT NULL,
    "lon" DECIMAL(9,6) NOT NULL,
    "lat" DECIMAL(8,6) NOT NULL,
    "name" TEXT,
    "houseNumber" TEXT,
    "street" TEXT,
    "locality" TEXT,
    "postalCode" TEXT,
    "country" TEXT NOT NULL,
    "createdAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,
    "updatedAt" TIMESTAMP(3) NOT NULL DEFAULT CURRENT_TIMESTAMP,

    CONSTRAINT "waypoint_pkey" PRIMARY KEY ("uuid")
);

-- AddForeignKey
ALTER TABLE "schedule_item" ADD CONSTRAINT "schedule_item_adUuid_fkey" FOREIGN KEY ("adUuid") REFERENCES "ad"("uuid") ON DELETE CASCADE ON UPDATE CASCADE;

-- AddForeignKey
ALTER TABLE "waypoint" ADD CONSTRAINT "waypoint_adUuid_fkey" FOREIGN KEY ("adUuid") REFERENCES "ad"("uuid") ON DELETE CASCADE ON UPDATE CASCADE;
