import { ValueObject } from '@mobicoop/ddd-library';
import { CoordinatesProps } from './coordinates.value-object';

/** Note:
 * Value Objects with multiple properties can contain
 * other Value Objects inside if needed.
 * */

export interface AddressProps {
  name?: string;
  houseNumber?: string;
  street?: string;
  locality?: string;
  postalCode?: string;
  country: string;
  coordinates: CoordinatesProps;
}

export class Address extends ValueObject<AddressProps> {
  get name(): string | undefined {
    return this.props.name;
  }

  get houseNumber(): string | undefined {
    return this.props.houseNumber;
  }

  get street(): string | undefined {
    return this.props.street;
  }

  get locality(): string | undefined {
    return this.props.locality;
  }

  get postalCode(): string | undefined {
    return this.props.postalCode;
  }

  get country(): string {
    return this.props.country;
  }

  get coordinates(): CoordinatesProps {
    return this.props.coordinates;
  }

  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  protected validate(props: AddressProps): void {
    return;
  }
}
